From bc2c8e1f4daa6f4c512a5d8d4563dd0009d0aa74 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 02 2020 04:24:39 +0000
Subject: [PATCH 807/2232] Access out dir through project struct


---

diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 0e77088..27f7a8d 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -110,7 +110,7 @@ impl Project {
         let target_dir = match cargo::target_dir() {
             target_dir @ TargetDir::Path(_) => target_dir,
             // Fallback if Cargo did not work.
-            TargetDir::Unknown => paths::search_parents_for_target_dir(),
+            TargetDir::Unknown => paths::search_parents_for_target_dir(&out_dir),
         };
 
         Ok(Project {
diff --git a/gen/build/src/paths.rs b/gen/build/src/paths.rs
index 47ceecc..e49dddb 100644
--- a/gen/build/src/paths.rs
+++ b/gen/build/src/paths.rs
@@ -70,20 +70,19 @@ pub(crate) fn out_with_extension(prj: &Project, path: &Path, ext: &str) -> Resul
     let mut file_name = path.file_name().unwrap().to_owned();
     file_name.push(ext);
 
-    let out_dir = out_dir()?;
     let rel = relative_to_parent_of_target_dir(prj, path)?;
-    Ok(out_dir.join(rel).with_file_name(file_name))
+    Ok(prj.out_dir.join(rel).with_file_name(file_name))
 }
 
 pub(crate) fn include_dir(prj: &Project) -> PathBuf {
     match &prj.target_dir {
         TargetDir::Path(target_dir) => target_dir.join("cxxbridge"),
-        TargetDir::Unknown => out_dir().unwrap().join("cxxbridge"), // FIXME no unwrap
+        TargetDir::Unknown => prj.out_dir.join("cxxbridge"),
     }
 }
 
-pub(crate) fn search_parents_for_target_dir() -> TargetDir {
-    let mut dir = match out_dir().and_then(canonicalize) {
+pub(crate) fn search_parents_for_target_dir(out_dir: &Path) -> TargetDir {
+    let mut dir = match out_dir.canonicalize() {
         Ok(dir) => dir,
         Err(_) => return TargetDir::Unknown,
     };

